<?php
namespace Bushelpowered\Api\Finops\V1;

use \Bushelpowered\Api\Finops\V1\Requests\GetDealerRequest;
use \Bushelpowered\Api\Finops\V1\Responses\GetDealerResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetDealer 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(GetDealerRequest $request, $headers): GetDealerResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/finops/v1/GetDealer', $request, $this->getWrapper(), $headers);
    }
    
    public function request(GetDealerRequest $request, GetDealerMetadata $hasHeaders): GetDealerResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/finops/v1/GetDealer', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var GetDealerResponse | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.finops.v1#GetDealerSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Finops\V1\Responses\GetDealerResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}